#include "matrix.h"

#ifndef OBJECT_H

#define X    0
#define Y    1
#define Z    2
#define H    3

struct vertex
{
   vector Coordinate;
   vector Transformed_Coordinate;
};

typedef struct vertex vertex;

struct object_info
{
   int             nvertex;
   vertex         *vertices;
   int             npoly;
   int           **poly_list;
   point           Min_point;
   point           Max_point;
   vertex       ***poly_vertices;
};

typedef struct object_info Object;

#define MAX(x,y) ((x > y)?x:y)
#define MIN(x,y) ((x < y)?x:y)

#endif

Object *init_object(char *datafilename, double xs, double ys, double zs);
void    transform_object(Transformation *View, Object *object);
void    draw_object(Viewer *viewer, Transformation *View, Object *object);
void draw_homogenize_line(Viewer *viewer, Transformation *View,
                          vertex *v0, vertex *v1);

